package org.cmdline.sudoku;

import java.util.*;
import javax.swing.Icon;

public class CannedGames implements Constants {
	
	private static Random random = null;
	private static long seed;
	
	private static final Vector easy = new Vector();
	private static final Vector medium = new Vector();
	private static final Vector hard = new Vector();
		
	private static final byte[] easy1 = new byte[] { 0,0,0,0,0,1,9,3,6,
													 4,0,9,0,2,0,0,1,0,
													 3,0,0,0,9,8,7,0,0,
													 0,5,0,8,3,0,0,0,2,
													 7,0,3,0,0,0,1,0,9,
													 6,0,0,0,7,4,0,8,0,
													 0,0,1,2,8,0,0,0,7,
													 0,4,0,0,6,0,8,0,1,
													 8,6,5,4,0,0,0,0,0 };

	private static final byte[] easy2 = new byte[] { 9,0,8,2,0,0,6,0,0,
													 0,1,0,9,0,0,4,0,8,
													 0,5,0,8,0,6,0,7,0,
													 0,0,1,0,7,4,9,0,0,
													 5,7,0,0,0,0,0,8,4,
													 0,0,9,3,2,0,5,0,0,
													 0,9,0,7,0,3,0,4,0,
													 2,0,4,0,0,9,0,5,0,
													 0,0,6,0,0,2,3,0,1 };
															
	
	private static final byte[] easy3 = new byte[] { 7,0,0,0,9,0,0,0,2,
													 0,4,0,0,1,0,0,9,0,
													 8,0,0,3,0,4,0,0,7,
													 9,0,8,0,0,0,5,0,4,
													 0,0,6,2,0,5,3,0,0,
													 2,0,4,0,0,0,6,0,1,
													 4,0,0,1,0,7,0,0,3,
													 0,9,0,0,2,0,0,1,0,
													 3,0,0,0,8,0,0,0,5 };
	
	private static final byte[] easy4 = new byte[] { 0,0,7,1,0,9,4,0,0,
													 0,2,4,7,0,0,0,8,0,
													 5,0,0,0,4,0,0,3,9,
													 4,0,0,0,7,0,0,5,6,
													 0,0,8,6,0,5,1,0,0,
													 6,9,0,0,8,0,0,0,3,
													 1,5,0,0,9,0,0,0,8,
													 0,6,0,0,0,4,9,2,0,
													 0,0,9,8,0,6,3,0,0 };
	
	private static final byte[] easy5 = new byte[] { 1,9,0,8,6,0,0,0,0,
													 0,0,2,7,4,0,0,0,8,
													 7,0,0,0,0,2,4,6,0,
													 2,0,5,0,0,4,0,9,0,
													 0,7,0,5,0,1,0,3,0,
													 0,8,0,2,0,0,1,0,6,
													 0,5,9,3,0,0,0,0,1,
													 3,0,0,0,5,8,6,0,0,
													 0,0,0,0,9,7,0,8,3 };
					
	private static final byte[] easy6 = new byte[] { 7,6,0,0,0,5,0,0,9,
													 0,0,0,0,9,4,0,8,0,
													 1,4,9,3,0,0,0,6,0,
													 0,0,5,0,7,0,4,0,1,
													 3,0,0,2,0,9,0,0,6,
													 8,0,7,0,6,0,2,0,0,
													 0,8,0,0,0,2,6,5,4,
													 0,7,0,5,3,0,0,0,0,
													 2,0,0,9,0,0,0,1,3 };
	
	private static final byte[] easy7 = new byte[] { 0,7,0,0,6,0,4,9,0,
													 0,5,0,0,7,8,0,6,0,
													 0,4,8,3,0,0,1,0,0,
													 7,9,0,0,1,0,0,0,0,
													 3,8,0,9,0,4,0,2,1,
													 0,0,0,0,3,0,0,5,6,
													 0,0,7,0,0,2,6,1,0,
													 0,6,0,7,9,0,0,3,0,
													 0,2,9,0,8,0,0,4,0 };
										
	private static final byte[] easy8 = new byte[] { 2,8,0,0,0,7,0,1,4,
													 1,7,0,0,8,2,0,0,6,
													 0,0,0,0,6,0,2,0,0,
													 0,3,0,0,0,5,7,2,0,
													 0,0,5,7,0,8,9,0,0,
													 0,6,2,3,0,0,0,5,0,
													 0,0,1,0,7,0,0,0,0,
													 5,0,0,4,1,0,0,7,2,
													 3,2,0,8,0,0,0,4,9 };
		
	private static final byte[] easy9 = new byte[] { 0,5,6,1,9,0,0,0,0,
													 0,1,0,0,0,2,5,3,4,
													 0,8,0,3,0,7,0,0,9,
													 0,3,9,0,0,0,1,0,6,
													 8,0,0,0,4,0,0,0,7,
													 5,0,4,0,0,0,2,9,0,
													 1,0,0,5,0,9,0,2,0,
													 2,7,5,4,0,0,0,6,0,
													 0,0,0,0,7,1,4,8,0 };
													 											 												 								 												 
	
	private static final byte[] easy10 = new byte[] { 0,0,0,4,0,3,5,7,0,
													  8,3,0,0,0,6,0,9,0,
													  4,0,1,9,0,0,2,0,0,
													  1,2,0,8,0,4,9,0,7,
													  0,0,0,0,0,0,0,0,0,
													  5,0,7,3,0,2,0,1,4,
													  0,0,8,0,0,9,6,0,3,
													  0,4,0,2,0,0,0,8,5,
													  0,5,6,1,0,8,0,0,0 };
		
	private static final byte[] easy11 = new byte[] { 0,0,2,4,0,5,0,1,0,
													  3,0,8,6,7,0,2,0,0,
													  0,7,0,0,0,0,0,6,5,
													  6,0,0,9,0,8,0,7,1,
													  0,8,0,0,5,0,0,3,0,
													  4,9,0,3,0,6,0,0,2,
													  7,2,0,0,0,0,0,4,0,
													  0,0,9,0,6,7,5,0,3,
													  0,1,0,2,0,9,6,0,0};
	
	private static final byte[] easy12 = new byte[] { 0,0,2,0,0,8,0,0,6,
													  0,0,9,0,0,1,0,7,0,
													  0,0,0,0,0,4,5,0,0,
													  0,3,0,0,5,0,0,1,0,
													  0,4,0,2,0,9,0,8,0,
													  0,7,0,0,0,6,0,3,0,
													  0,0,6,7,0,0,0,0,0,
													  0,5,0,8,0,0,4,0,0,
													  8,0,0,9,0,0,3,0,0 };
				
	private static final byte[] easy13 = new byte[] { 6,9,0,0,0,3,0,8,2,
													  4,7,0,0,9,1,0,0,5,
													  0,0,0,0,8,0,1,0,0,
													  0,5,0,0,0,2,7,6,0,
													  0,0,2,6,0,9,3,0,0,
													  0,6,7,5,0,0,0,2,0,
													  0,0,9,0,6,0,0,0,0,
													  8,0,0,1,2,0,0,9,7,
													  2,1,0,9,0,0,0,4,6 };
													  
	private static final byte[] easy14 = new byte[] { 1,0,0,0,0,0,0,0,3,
													  3,0,0,4,0,1,0,0,6,
													  0,0,4,7,8,3,5,0,0,
													  0,1,0,3,0,6,0,9,0,
													  0,5,0,0,0,0,0,4,0,
													  0,3,0,2,0,7,0,8,0,
													  0,0,6,1,9,5,2,0,0,
													  9,0,0,6,0,2,0,0,4,
													  5,0,0,0,0,0,0,0,7 };
													  
	private static final byte[] easy15 = new byte[] { 0,7,0,5,1,9,0,3,0,
													  6,0,0,0,0,0,0,0,8,
													  0,0,5,0,0,0,2,0,0,
													  8,2,0,9,0,4,0,6,5,
													  0,0,0,0,6,0,0,0,0,
													  4,6,0,3,0,1,0,2,9,
													  0,0,6,0,0,0,5,0,0,
													  9,0,0,0,0,0,0,0,2,
													  0,3,0,8,4,6,0,7,0 };
													  									  											  											  
	private static final byte[] medium1 = new byte[] { 7,0,0,0,0,6,0,2,0,
													   0,0,0,4,8,0,0,3,0,
													   0,9,0,7,0,0,0,0,6,
													   0,7,2,0,6,0,0,0,0,
													   9,0,0,1,0,3,0,0,4,
													   0,0,0,0,9,0,1,8,0,
													   3,0,0,0,0,8,0,1,0,
													   0,8,0,0,4,5,0,0,0,
													   0,6,0,2,0,0,0,0,9 };
		
	private static final byte[] medium2 = new byte[] { 0,0,9,0,0,0,0,7,2,
													   0,7,5,0,1,9,0,0,0,
													   8,0,0,5,0,0,0,0,0,
													   9,0,1,7,0,3,0,0,0,
													   0,4,0,0,0,0,0,8,0,
													   0,0,0,8,0,2,1,0,4,
													   0,0,0,0,0,1,0,0,6,
													   0,0,0,4,5,0,2,9,0,
													   6,5,0,0,0,0,7,0,0 };
	
	private static final byte[] medium3 = new byte[] { 0,4,3,5,0,0,0,0,0,
													   2,0,0,0,9,0,0,0,8,
													   0,0,0,0,1,0,0,0,2,
													   3,0,6,0,0,5,0,7,0,
													   7,9,0,0,0,0,0,3,6,
													   0,5,0,6,0,0,8,0,9,
													   8,0,0,0,6,0,0,0,0,
													   1,0,0,0,3,0,0,0,4,
													   0,0,0,0,0,7,2,8,0 };
	
	private static final byte[] medium4 = new byte[] { 0,0,0,1,0,0,0,0,0,
													   3,0,0,0,4,7,0,9,0,
													   0,9,1,0,6,0,3,5,4,
													   0,6,0,0,0,0,2,3,0,
													   0,0,0,7,0,6,0,0,0,
													   0,5,9,0,0,0,0,1,0,
													   8,7,2,0,9,0,4,6,0,
													   0,3,0,8,5,0,0,0,7,
													   0,0,0,0,0,2,0,0,0 };
	
	private static final byte[] medium5 = new byte[] { 9,7,1,0,0,0,0,3,2,
													   0,0,0,9,1,0,0,8,0,
													   0,0,0,0,0,6,0,0,0,
													   0,2,6,0,0,0,1,0,0,
													   0,0,0,8,0,3,0,0,0,
													   0,0,8,0,0,0,4,5,0,
													   0,0,0,3,0,0,0,0,0,
													   0,4,0,0,7,5,0,0,0,
													   5,1,0,0,0,0,3,2,6 };
	
	private static final byte[] medium6 = new byte[] { 0,1,9,0,0,0,0,4,0,
													   7,0,0,0,0,4,0,5,0,
													   3,0,0,8,0,1,9,0,0,
													   0,3,0,0,2,0,7,0,9,
													   0,0,0,0,0,0,0,0,0,
													   1,0,2,0,7,0,0,3,0,
													   0,0,1,4,0,6,0,0,7,
													   0,2,0,5,0,0,0,0,3,
													   0,4,0,0,0,0,5,8,0 };
	
	private static final byte[] medium7 = new byte[] { 0,0,4,8,0,9,5,0,0,
													   3,0,2,0,0,0,8,1,0,
													   0,0,0,0,3,1,0,0,0,
													   0,0,0,0,9,7,6,0,1,
													   4,0,0,0,0,0,0,0,2,
													   7,0,9,1,6,0,0,0,0,
													   0,0,0,2,5,0,0,0,0,
													   0,1,6,0,0,0,2,0,9,
													   0,0,3,9,0,8,4,0,0 };
	
	private static final byte[] medium8 = new byte[] { 0,0,5,9,3,0,8,0,2,
													   6,0,2,5,0,0,0,0,3,
													   0,7,0,0,0,0,0,0,0,
													   8,0,1,0,0,6,0,0,0,
													   0,0,6,0,0,0,5,0,0,
													   0,0,0,1,0,0,4,0,6,
													   0,0,0,0,0,0,0,7,0,
													   2,0,0,0,0,1,6,0,4,
													   5,0,9,0,8,4,3,0,0 };
	
	private static final byte[] medium9 = new byte[] { 0,3,0,7,9,4,0,6,0,
													   4,0,0,0,0,0,0,0,3,
													   0,0,8,0,0,0,2,0,0,
													   6,1,0,2,0,8,0,9,7,
													   0,0,0,0,7,0,0,0,0,
													   2,8,0,9,0,1,0,4,5,
													   0,0,6,0,0,0,4,0,0,
													   1,0,0,0,0,0,0,0,6,
													   0,2,0,6,5,9,0,8,0 };
	
	private static final byte[] medium10 = new byte[] { 0,0,8,9,0,0,5,4,0,
														4,0,0,0,0,0,1,0,3,
														0,6,0,0,5,0,0,0,8,
														0,7,0,0,0,1,2,0,0,
														0,0,0,7,0,6,0,0,0,
														0,0,1,8,0,0,0,3,0,
														2,0,0,0,9,0,0,1,0,
														8,0,5,0,0,0,0,0,4,
														0,3,6,0,0,7,9,0,0 };
	
	private static final byte[] medium11 = new byte[] { 3,0,0,0,0,8,7,0,0,
														0,0,0,0,0,9,0,0,4,
														1,0,0,0,6,0,0,0,2,
														0,0,5,0,2,3,0,8,0,
														0,7,0,0,0,4,0,9,0,
														0,6,0,0,0,1,5,0,0,
														8,0,0,0,5,0,0,0,6,
														7,0,0,1,0,0,0,0,0,
														0,0,9,8,0,0,0,0,5 };
													    
	
	private static final byte[] medium12 = new byte[] { 9,0,0,0,1,0,0,3,0,
														0,2,0,7,0,0,0,4,0,
														0,0,0,5,0,0,0,6,0,
														8,0,0,0,0,9,7,0,0,
														0,0,3,6,0,0,5,0,0,
														0,0,1,0,4,2,0,0,8,
														0,4,0,0,0,3,0,0,0,
														0,8,0,0,0,1,0,5,0,
														0,1,0,0,7,0,0,0,6 };
														
			
	private static final byte[] medium13 = new byte[] { 0,0,0,0,5,7,0,0,0,
														0,3,5,2,0,0,0,0,1,
														9,7,1,0,8,0,0,0,0,
														5,0,0,0,0,0,2,9,0,
														0,2,3,0,0,0,6,5,0,
														0,8,9,0,0,0,0,0,7,
														0,0,0,0,9,0,3,4,2,
														6,0,0,0,0,8,7,1,0,
														0,0,0,4,1,0,0,0,0 };
														
	private static final byte[] medium14 = new byte[] { 0,0,0,0,0,6,8,0,0,
														0,5,0,0,7,0,0,0,9,
														0,0,2,4,0,0,0,0,1,
														0,3,0,0,5,0,6,0,0,
														4,0,0,2,9,0,0,0,7,
														0,0,1,0,8,0,0,3,0,
														9,0,0,0,0,1,4,0,0,
														7,0,0,0,2,0,0,5,0,
														0,0,5,7,0,0,0,0,0 };
		
	private static final byte[] medium15 = new byte[] { 0,0,0,0,6,0,4,0,1,
													    4,3,0,1,2,0,0,7,0,
													    0,0,0,0,0,0,0,2,0,
													    0,0,0,0,9,4,8,0,7,
													    2,8,0,0,1,0,0,4,9,
													    9,0,4,5,3,0,0,0,0,
													    0,4,0,0,0,0,0,0,0,
													    0,2,0,0,7,1,0,3,4,
													    5,0,1,0,8,0,0,0,0 };
													    												
	private static final byte[] hard1 = new byte[] { 8,0,0,9,0,3,0,0,7,
													 0,0,0,0,0,0,0,0,0,
													 6,1,7,0,0,0,9,8,3,
													 0,0,6,8,0,2,3,0,0,
													 9,0,0,0,0,0,0,0,2,
													 0,0,1,5,0,6,4,0,0,
													 1,3,4,0,0,0,5,2,6,
													 0,0,0,0,0,0,0,0,0,
													 7,0,0,3,0,1,0,0,4 };
	
	private static final byte[] hard2 = new byte[] { 0,9,0,0,0,2,0,0,0,
													 5,0,0,4,3,0,9,8,0,
													 1,0,4,0,0,0,0,6,0,
													 0,7,3,0,6,0,0,0,0,
													 0,0,0,1,0,8,0,0,0,
													 0,0,0,0,2,0,6,5,0,
													 0,4,0,0,0,0,3,0,6,
													 0,8,1,0,9,5,0,0,4,
													 0,0,0,7,0,0,0,1,0 };		
													 
	private static final byte[] hard3 = new byte[] { 9,0,0,0,5,0,0,0,1,
													 0,4,0,0,9,0,0,7,0,
													 5,0,0,4,0,1,0,0,8,
													 7,0,3,0,0,0,8,0,4,
													 0,0,2,3,0,9,5,0,0,
													 1,0,5,0,0,0,7,0,3,
													 3,0,0,9,0,6,0,0,2,
													 0,2,0,0,3,0,0,6,0,	
													 6,0,0,0,8,0,0,0,9 };
													 		
	private static final byte[] hard4 = new byte[] { 2,0,0,0,0,1,0,6,0,
													 0,0,0,8,2,0,0,5,0,
													 0,4,0,7,0,0,0,0,1,
													 0,3,9,0,1,0,0,0,0,
													 8,0,0,3,0,2,0,0,9,
													 0,0,0,0,4,0,7,3,0,
													 3,0,0,0,0,5,0,1,0,
													 0,6,0,0,8,4,0,0,0,
													 0,7,0,6,0,0,0,0,2 };
	
	private static final byte[] hard5 = new byte[] { 8,0,0,4,0,0,0,0,0,
													 7,5,0,0,3,0,0,0,0,
													 0,0,9,0,0,0,4,3,0,
													 0,4,0,8,0,3,0,0,7,
													 9,0,0,1,0,6,0,0,3,
													 2,0,0,5,0,9,0,6,0,
													 0,6,7,0,0,0,3,0,0,
													 0,0,0,0,9,0,0,1,4,
													 0,0,0,0,0,5,0,0,2 };
	
	private static final byte[] hard6 = new byte[] { 0,0,6,0,0,0,7,0,0,
													 0,0,2,7,0,4,3,0,0,
													 1,0,0,0,9,0,0,0,6,
													 0,5,3,6,0,9,2,8,0,
													 0,0,0,0,0,0,0,0,0,
													 0,8,9,5,0,7,6,4,0,
													 3,0,0,0,8,0,0,0,9,
													 0,0,5,1,0,3,8,0,0,
													 0,0,4,0,0,0,1,0,0 };
	
	private static final byte[] hard7 = new byte[] { 7,9,0,0,0,3,0,0,0,
												     8,0,0,0,5,0,0,0,0,
												     0,1,0,0,0,4,7,0,0,
												     0,8,0,0,6,0,0,0,5,
												     2,0,3,0,7,0,9,0,8,
												     5,0,0,0,3,0,0,4,0,
												     0,0,6,5,0,0,0,8,0,
												     0,0,0,0,8,0,0,0,2,
												     0,0,0,7,0,0,0,1,9 };
	
	private static final byte[] hard8 = new byte[] { 3,8,0,0,1,0,7,0,9,
													 0,0,9,0,0,0,0,0,6,
													 6,0,0,0,0,8,0,4,0,
													 0,0,3,8,0,7,0,0,0,
													 8,0,0,0,9,0,0,0,7,
													 0,0,0,1,0,5,8,0,0,
													 0,2,0,6,0,0,0,0,5,
													 9,0,0,0,0,0,4,0,0,	
												     4,0,1,0,3,0,0,2,8 };
												     
	private static final byte[] hard9 = new byte[] { 0,0,0,0,0,1,0,8,0,
													 1,7,0,0,0,4,2,0,0,
													 0,9,0,5,0,0,6,0,0,
													 0,1,0,0,5,2,0,3,0,
													 2,0,0,0,0,0,0,0,5,
													 0,8,0,6,4,0,0,7,0,
													 0,0,9,0,0,8,0,4,0,
													 0,0,2,4,0,0,0,9,6,
													 0,5,0,7,0,0,0,0,0 };
	
	private static final byte[] hard10 = new byte[] { 8,0,0,2,0,0,0,7,9,
													  0,5,0,0,3,0,0,0,0,
													  7,2,0,0,0,5,0,6,0,
													  5,0,4,0,9,1,0,0,0,
													  0,0,0,0,0,0,0,0,0,
													  0,0,0,6,2,0,7,0,5,
													  0,8,0,3,0,0,0,1,4,
													  0,0,0,0,6,0,0,8,0,
													  3,1,0,0,0,9,0,0,7 };
	
	private static final byte[] hard11 = new byte[] { 0,6,0,0,0,3,9,0,0,
													  5,0,0,1,0,0,0,0,0,
													  8,0,0,0,0,0,0,0,7,
													  0,4,0,2,0,0,6,0,0,
													  7,0,0,0,0,0,0,0,8,
													  0,0,3,0,0,9,0,1,0,
													  2,0,0,0,0,0,0,0,5,
													  0,0,0,0,0,4,0,0,3,
													  0,0,8,7,0,0,0,2,0 };
													  
	private static final byte[] hard12 = new byte[] { 0,0,8,5,0,0,0,4,0,
													  0,0,9,0,0,6,0,2,0,
													  0,0,0,1,0,0,7,0,0,
													  3,0,0,0,8,0,0,0,9,
													  0,0,5,0,0,0,1,0,0,
													  4,0,0,7,0,0,0,0,6,
													  0,0,2,0,0,3,0,0,0,
													  0,7,0,4,0,0,5,0,0,
													  0,1,0,0,0,2,3,0,0 };
	
	private static final byte[] hard13 = new byte[] { 0,0,6,0,0,0,7,0,0,
													  8,0,0,0,0,9,2,0,0,
													  0,4,0,0,1,0,0,0,0,
													  3,0,0,0,0,0,0,0,5,
													  2,0,0,0,0,8,0,0,9,
													  1,0,0,7,0,0,0,0,4,
													  0,0,0,0,6,0,0,3,0,
													  0,0,5,4,0,0,0,0,8,
													  0,0,7,0,0,0,6,0,0 };
													  
	private static final byte[] hard14 = new byte[] { 0,0,0,6,2,0,0,3,0,
													  0,0,0,1,3,0,5,0,0,
													  0,0,0,9,0,0,8,1,0,
													  5,1,0,3,0,0,6,9,0,
													  0,0,3,0,0,0,2,0,0,
													  0,8,9,0,0,1,0,5,4,
													  0,9,8,0,0,6,0,0,0,
													  0,0,5,0,1,3,0,0,0,
													  0,6,0,0,4,9,0,0,0 };
													  
	private static final byte[] hard15 = new byte[] { 4,6,0,0,2,0,0,0,0,
													  0,1,0,7,0,3,0,8,0,
													  3,0,9,8,4,0,0,0,0,
													  1,3,0,0,0,0,8,0,0,
													  6,0,0,0,0,0,0,0,5,
													  0,0,5,0,0,0,0,4,1,
													  0,0,0,0,1,2,9,0,7,
													  0,2,0,3,0,4,0,5,0,
													  0,0,0,0,8,0,0,3,4 };												
													  											  												  												 
	static {
		easy.addElement(easy1);
		easy.addElement(easy2);
		easy.addElement(easy3);
		easy.addElement(easy4);
		easy.addElement(easy5);
		easy.addElement(easy6);
		easy.addElement(easy7);
		easy.addElement(easy8);
		easy.addElement(easy9);
		easy.addElement(easy10);
		easy.addElement(easy11);
		easy.addElement(easy12);
		easy.addElement(easy13);
		easy.addElement(easy14);
		easy.addElement(easy15);
		medium.addElement(medium1);
		medium.addElement(medium2);
		medium.addElement(medium3);
		medium.addElement(medium4);
		medium.addElement(medium5);
		medium.addElement(medium6);
		medium.addElement(medium7);
		medium.addElement(medium8);
		medium.addElement(medium9);
		medium.addElement(medium10);
		medium.addElement(medium11);
		medium.addElement(medium12);
		medium.addElement(medium13);
		medium.addElement(medium14);
		medium.addElement(medium15);
		hard.addElement(hard1);
		hard.addElement(hard2);
		hard.addElement(hard3);
		hard.addElement(hard4);
		hard.addElement(hard5);
		hard.addElement(hard6);
		hard.addElement(hard7);
		hard.addElement(hard8);
		hard.addElement(hard9);
		hard.addElement(hard10);
		hard.addElement(hard11);
		hard.addElement(hard12);
		hard.addElement(hard13);
		hard.addElement(hard14);
		hard.addElement(hard15);
	}
	
	public static final void setSeed(long value) { 
		seed = value; 
		random = new Random(seed);
	}
	
	public static void list(Vector rows,String solved) {
		int offset = 0;
		for (int i=0;i<easy.size();i++) {
			Icon ico = null;
			if (solved != null && solved.charAt(offset+i) == '1')
				ico = PuzzleList.solvedCkMark;
			Vector row = new Vector(Arrays.asList(
				new Object[] { new ListTableCell(0,null,ico),
							   new ListTableCell(1,getTitle(EASY,i),PuzzleList.puzzleIcon[0]),
							   new ListTableCell(2,"Easy",null) }));
			rows.addElement(row);
		}
		offset += easy.size();
		for (int i=0;i<medium.size();i++) {
			Icon ico = null;
			if (solved != null && solved.charAt(offset+i) == '1')
				ico = PuzzleList.solvedCkMark;
			Vector row = new Vector(Arrays.asList(
				new Object[] { new ListTableCell(0,null,null),
							   new ListTableCell(1,getTitle(MEDIUM,i),PuzzleList.puzzleIcon[1]),
							   new ListTableCell(2,"Medium",null) }));
			rows.addElement(row);	
		}		
		offset += medium.size();
		for (int i=0;i<hard.size();i++) {
			Icon ico = null;
			if (solved != null && solved.charAt(offset+i) == '1')
				ico = PuzzleList.solvedCkMark;
			Vector row = new Vector(Arrays.asList(
				new Object[] { new ListTableCell(0,null,null),
							   new ListTableCell(1,getTitle(HARD,i),PuzzleList.puzzleIcon[1]),
							   new ListTableCell(2,"Hard",null) }));
			rows.addElement(row);
		}		
	}

	public static Vector getGame(String title) {
		Vector v = null, retv = new Vector();
		int offset = 0;
		String[] s = title.split("[#[\\s]]");
		String level = s[1].trim();
		if (level.equals("easy")) v = easy;
		else if (level.equals("medium")) {
			offset += easy.size();
			v = medium;
		}
		else if (level.equals("hard")) {
			offset += easy.size() + medium.size();
			v = hard;
		}
		else throw new IllegalArgumentException("CannedGames: get game for " + title + " didn't find level");
		int idx = new Integer(s[3].trim()).intValue() - 1;
		retv.addElement(v.elementAt(idx));
		retv.addElement(new Integer(offset+idx));
		return retv;
	}
		
	public static String getTitle(int level,int index) {
		StringBuffer title = new StringBuffer("SSS ");
		if (level == EASY) title.append("easy #");
		else if (level == MEDIUM) title.append("medium #");
		else title.append("hard #");
		title.append(new Integer(index+1).toString());
		return title.toString();
	}
	
	public static Vector getGame(int level) {
		Vector retv = new Vector();
		int offset = 0, idx = 0;
		if (level == EASY) {
			idx = Math.abs(random.nextInt()) % (easy.size()-1);
			retv.addElement(easy.elementAt(idx));
			retv.addElement(new Integer(offset+idx));
			return retv;
		} 
		else if (level == MEDIUM) {
			offset += easy.size();
			idx = Math.abs(random.nextInt()) % (medium.size()-1);
			retv.addElement(medium.elementAt(idx));
			retv.addElement(new Integer(offset+idx));
			return retv;
		}
		else if (level == HARD) {
			offset += easy.size() + medium.size();
			idx = Math.abs(random.nextInt()) % (hard.size()-1);
			retv.addElement(hard.elementAt(idx));
			retv.addElement(new Integer(offset+idx));
			return retv;
		}
		throw new IllegalArgumentException("Unsupported level " + level);
	}
}